* Interface between the TExaS simulator running a MC68HC11 EVB
*      and the ImageCraft ICC11 freeware complier 
* TExaS Copyright 1999 by Jonathan W. Valvano 
* ICC11 Copyright (c) 1993, 1994 by ImageCraft, Richard Man, and Christina Willrich
* to upgrade the compiler see http://www.imagecraft.com

* specify program and data segments
	sect 0		* code goes in MC68HC11 EVB PROM
        org $C000
	sect 1		* data (globals) go in MC68HC11 EVB external RAM
        org $6000
* note: if the RAM section is set in page 0 then phasing errors occur
* so, when using the ICC11 freeware compiler, 
* the TExaS simulator should be run only with the 68HC11 EVB  
stackbase equ $7FFF     * stack grows down from top of MC68HC11 EVB external RAM
*
* start of code
*
	sect 0
__start: lds  #stackbase
	jsr  _main
	stop           * TExaS simulation halt
__lsrd:
	cpy  #0
	beq  __lsrd_done
	lsrd
	dey
	bra __lsrd
__lsrd_done:
	rts
__lsld:
	cpy #0
	beq  __lsld_done
	lsld
	dey
	bra  __lsld
__lsld_done:
	rts
__asrd:
	cmpa #0
	bpl  __lsrd
__asrd_loop:
	cpy  #0
	beq  __asrd_done
	asra
	rorb
	dey
	bra  __asrd_loop
__asrd_done:
	rts
__asgnblk:
	cpd  #0
	beq  __asgnblk_done
__asgnblk_loop:
	pshb
	ldab 0,y
	stab 0,x
	pulb
	subd #1
	beq  __asgnblk_done
	inx
	iny
	bra  __asgnblk_loop
__asgnblk_done:
	rts
__muli:
__mulu:
	pshx
	pshy
	pshb
	psha
	tsx
	ldaa 3,x
	mul
	pshb
	psha
	ldab 0,x
	ldaa 3,x
	mul
	pula
	aba
	psha
	ldab 1,x
	ldaa 2,x
	mul
	pula
	aba
	pulb
	pulx
	pulx
	pulx
	rts
__divi:
	pshx		
	psha	
	tsta
	bpl  __divi_1
	coma
	comb
	addd  #1
__divi_1:	
	pshy		
	pulx	
	tsy
	cpx  #0
	bpl  __divi_2
	xgdx
	coma
	comb
	xgdx
	inx
	com  0,y
__divi_2:	
	idiv
	xgdx
	tst  0,y	
	bpl  __divi_3
	coma	
	comb
	addd  #1
__divi_3:	
	ins
	pulx
	rts
__modi:
	pshx
	psha
	tsta
	bpl  __modi_1
	coma	
	comb
	addd  #1
__modi_1:	
	pshy
	pulx
	cpx  #0
	bpl  __modi_2
	xgdx	
	coma
	comb
	xgdx
	inx
__modi_2:	
	idiv
	tsx	
	tst  0,x
	bpl  __modi_3
	coma	
	comb
	addd  #1
__modi_3:	
	ins		
	pulx
	rts

***************_putchar***********************
* Output one character to SCI terminal
* Inputs: ASCII character    Outputs: none
* Registers modified: A,B,CCR
_putchar:   
	tsy
	ldaa 3,y
__putWait:
        ldab $102e
        andb #$80
        beq  __putWait  Gadfly wait for TDRE
* TDRE=1 when ready for more output
        staa $102f          Start Output
        rts
* * * * * * * * End of _putchar * * * * * * * * 
